#!/bin/bash

SAVE=0
path=$2
quality=$1


usage()
{
    cat << EOF
    usage: $0 compression-rate directory
EOF
}

if [ $# -lt 2 ];
then
    usage
    exit -1
fi


if [ ! -d "$path" ];
then
    echo "Director $path does not exist"
    exit -1
fi

# Action part
cd $path
min=999999999
max=

for fd in *.jpg
do
    tempname="temp_$fd"
    cp $fd $tempname
    mogrify -compress jpeg -quality $quality $tempname
    res=`du -b $tempname`
    array=(`echo $res | tr " " "\n"`)
    size="${array[0]}"

    if [[ "$size" -gt "$max" ]]
    then
        max=$size
    fi

    if [[ "$size" -lt "$min" ]]
    then
        min=$size
    fi

done

span=$(($max - $min))
counter=0

for fd in temp_*
do
    res=`du -b $fd`
    array=(`echo $res | tr " " "\n"`)
    size="${array[0]}"

    diff=$(($size - $min))
    #ratio=$(echo "$diff / $span" | bc -l)
    ratio=$(awk -v diff=$diff -v span=$span 'BEGIN { print diff/span }')

    echo "$counter $ratio"

    counter=$(($counter + 1))

    rm $fd
done
