
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

void getPeaks( int &n, int peaks[] );
int  min( int a, int b );
int  min( int a, int b, int c );
int  min( int a, int b, int c, int d );

int
main()
{
    bool detail = false;		// print all the details?
    int i, n;
    int true_positive;
    int false_positive;
    int false_negative;
    int true_negative;
    int error;
    int peaks[256];
    int instances = 0;		// accumulate statistics
    double precision = 0.0;
    double recall = 0.0;
    double specificity = 0.0;
    double mean_error = 0.0;	// mean absolute prediction error

    // Backyard: 156
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 156 ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += abs(peaks[i] - 156);
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 156 ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
	printf( "-------------------\n" );
	printf( "Backyard:   %3d %3d\n", true_positive, false_positive );
	printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Bench: (153, 154)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 153) ||
	    (peaks[i] == 154) ) {
	    true_positive++;
	}
	else {
            false_positive++;
	    error += min( abs(peaks[i] - 153),
	    		  abs(peaks[i] - 154) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 153) ||
	    (peaks[i] == 154) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Bench:      %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Book: (22, 23, 24)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 22) ||
	    (peaks[i] == 23) ||
	    (peaks[i] == 24) ) {
	    true_positive++;
	}
	else {
            false_positive++;
	    error += min( abs(peaks[i] - 22),
	    		  abs(peaks[i] - 23),
	    		  abs(peaks[i] - 24) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 22) ||
	    (peaks[i] == 23) ||
	    (peaks[i] == 24) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Book:       %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Bridge: 163
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 163 ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += abs(peaks[i] - 163);
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 163 ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
	printf( "-------------------\n" );
	printf( "Bridge:     %3d %3d\n", true_positive, false_positive );
	printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Building1: 163
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 163 ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += abs(peaks[i] - 163);
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 163 ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Building1:  %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Building2: (162, 163)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 162) ||
	    (peaks[i] == 163) ) {
	    true_positive++;
	}
	else {
            false_positive++;
	    error += min( abs(peaks[i] - 162),
	    		  abs(peaks[i] - 163) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 162) ||
	    (peaks[i] == 163) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Building2:  %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Building3: (161, 162)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 161) ||
	    (peaks[i] == 162) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] - 161),
	    		  abs(peaks[i] - 162) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 161) ||
	    (peaks[i] == 162) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Building3:  %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Cat: (66,67), 175
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  66) ||
	    (peaks[i] ==  67) ||
	    (peaks[i] == 175) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] -  66),
	    		  abs(peaks[i] -  67),
	    		  abs(peaks[i] - 175) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  66) ||
	    (peaks[i] ==  67) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 175 ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 231 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Cat:        %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 2.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Cup1: (103, 104)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 103) ||
	    (peaks[i] == 104) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] - 103),
	    		  abs(peaks[i] - 104) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 103) ||
	    (peaks[i] == 104) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Cup1:       %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Cup2: 99, (106, 107)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  99) ||
	    (peaks[i] == 106) ||
	    (peaks[i] == 107) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] -  99),
	    		  abs(peaks[i] - 106),
	    		  abs(peaks[i] - 107) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 99 ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 106) ||
	    (peaks[i] == 107) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Cup2:       %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 2.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Cup3: (101, 102), (123, 124)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 101) ||
	    (peaks[i] == 102) ||
	    (peaks[i] == 123) ||
	    (peaks[i] == 124) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min(
			min( abs(peaks[i] - 101),
			     abs(peaks[i] - 102) ),
			min( abs(peaks[i] - 123),
			     abs(peaks[i] - 124) )
			);
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 101) ||
	    (peaks[i] == 102) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 123) ||
	    (peaks[i] == 124) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Cup3:       %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 2.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Cup4: 88, 116, (136, 137), (159, 160)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  88) ||
	    (peaks[i] == 116) ||
	    (peaks[i] == 136) ||
	    (peaks[i] == 137) ||
	    (peaks[i] == 159) ||
	    (peaks[i] == 160) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min(
			min( abs(peaks[i] -  88),
	    		     abs(peaks[i] - 116),
	    		     abs(peaks[i] - 136) ),
			min( abs(peaks[i] - 137),
	    		     abs(peaks[i] - 159),
	    		     abs(peaks[i] - 160) ) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( peaks[i] ==  88 ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 116 ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 136) ||
	    (peaks[i] == 137) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 159) ||
	    (peaks[i] == 160) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Cup4:       %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 4.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Fabric: (101, 102, 103)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 101) ||
	    (peaks[i] == 102) ||
	    (peaks[i] == 103) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] - 101),
	    		  abs(peaks[i] - 102),
	    		  abs(peaks[i] - 103) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 101) ||
	    (peaks[i] == 102) ||
	    (peaks[i] == 103) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Fabric:     %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Flower: 25, (109, 110)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  25) ||
	    (peaks[i] == 109) ||
	    (peaks[i] == 110) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] -  25),
	    		  abs(peaks[i] - 109),
	    		  abs(peaks[i] - 110) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 25 ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 109) ||
	    (peaks[i] == 110) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Flower:     %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 2.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Interior1: (149, 150, 151)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 149) ||
	    (peaks[i] == 150) ||
	    (peaks[i] == 151) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] - 149),
	    		  abs(peaks[i] - 150),
	    		  abs(peaks[i] - 151) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 149) ||
	    (peaks[i] == 150) ||
	    (peaks[i] == 151) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Interior1:  %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Interior2: (105, 106), (134, 135), (139, 140), (152, 153, 154)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 105) ||
	    (peaks[i] == 106) ||
	    (peaks[i] == 134) ||
	    (peaks[i] == 135) ||
	    (peaks[i] == 139) ||
	    (peaks[i] == 140) ||
	    (peaks[i] == 152) ||
	    (peaks[i] == 153) ||
	    (peaks[i] == 154) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min(
			min( abs(peaks[i] - 105),
	    		     abs(peaks[i] - 106) ),
			min( abs(peaks[i] - 134),
	    		     abs(peaks[i] - 135) ),
			min( abs(peaks[i] - 139),
	    		     abs(peaks[i] - 140) ),
			min( abs(peaks[i] - 152),
	    		     abs(peaks[i] - 153),
	    		     abs(peaks[i] - 154) ) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 105) ||
	    (peaks[i] == 106) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 134) ||
	    (peaks[i] == 135) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 139) ||
	    (peaks[i] == 140) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 152) ||
	    (peaks[i] == 153) ||
	    (peaks[i] == 154) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Interior2:  %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 4.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Lamp: (62, 63, 64), (106, 107), (134, 135), 159
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  62) ||
	    (peaks[i] ==  63) ||
	    (peaks[i] ==  64) ||
	    (peaks[i] == 106) ||
	    (peaks[i] == 107) ||
	    (peaks[i] == 134) ||
	    (peaks[i] == 135) ||
	    (peaks[i] == 159) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min(
			min( abs(peaks[i] -  62),
	    		     abs(peaks[i] -  63),
	    		     abs(peaks[i] -  64) ),
			min( abs(peaks[i] - 106),
	    		     abs(peaks[i] - 107) ),
			min( abs(peaks[i] - 134),
	    		     abs(peaks[i] - 135),
	    		     abs(peaks[i] - 159) ) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  62) ||
	    (peaks[i] ==  63) ||
	    (peaks[i] ==  64) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 106) ||
	    (peaks[i] == 107) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 134) ||
	    (peaks[i] == 135) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 159 ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Lamp:       %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 4.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Landscape1: 162
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 162 ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += abs(peaks[i] - 162);
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 162 ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Landscape1: %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Landscape2: 163
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 163 ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += abs(peaks[i] - 163);
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 163 ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Landscape2: %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Landscape3: (164, 165)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 164) ||
	    (peaks[i] == 165) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] - 164),
	    		  abs(peaks[i] - 165) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 164) ||
	    (peaks[i] == 165) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Landscape3: %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Moon: 225
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 225 ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += abs(peaks[i] - 225);
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 225 ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 231 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Moon:       %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Screen: (19,20), 157
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  19) ||
	    (peaks[i] ==  20) ||
	    (peaks[i] == 157) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] -  19),
	    		  abs(peaks[i] -  20),
	    		  abs(peaks[i] - 157) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  19) ||
	    (peaks[i] ==  20) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( peaks[i] == 157 ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Screen:     %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 2.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Snails: (96, 97)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 96) ||
	    (peaks[i] == 97) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] - 96),
	    		  abs(peaks[i] - 97) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 96) ||
	    (peaks[i] == 97) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Snails:     %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // StillLife: (136, 137)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 136) ||
	    (peaks[i] == 137) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] - 136),
	    		  abs(peaks[i] - 137) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  136) ||
	    (peaks[i] ==  137) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "StillLife:  %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // Vase: (82, 83)
    getPeaks( n, peaks );
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 82) ||
	    (peaks[i] == 83) ) {
	    true_positive++;
	}
	else {
            false_positive++;
	    error += min( abs(peaks[i] - 82),
	    		  abs(peaks[i] - 83) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 82) ||
	    (peaks[i] == 83) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Vase:       %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;

    // LowLight (Candle1): (115, 116), (120, 121), (126, 127, 128)
    getPeaks( n, peaks );
/*
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 115) ||
	    (peaks[i] == 116) ||
	    (peaks[i] == 120) ||
	    (peaks[i] == 121) ||
	    (peaks[i] == 126) ||
	    (peaks[i] == 127) ||
	    (peaks[i] == 128) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min(
			min( abs(peaks[i] - 115),
	    		     abs(peaks[i] - 116) ),
			min( abs(peaks[i] - 120),
	    		     abs(peaks[i] - 121) ),
			min( abs(peaks[i] - 126),
	    		     abs(peaks[i] - 127),
	    		     abs(peaks[i] - 128) ) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 115) ||
	    (peaks[i] == 116) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 120) ||
	    (peaks[i] == 121) ) break;
    }
    if( i >= n ) false_negative++;
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 126) ||
	    (peaks[i] == 127) ||
	    (peaks[i] == 128) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Candle1:    %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 4.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;
*/

    // LowLight (Candle2): (124, 125)
    getPeaks( n, peaks );
/*
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 124) ||
	    (peaks[i] == 125) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] - 124),
	    		  abs(peaks[i] - 125) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] == 124) ||
	    (peaks[i] == 125) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "Candle2:    %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;
*/

    // LowLight (Cup): (91, 92)
    getPeaks( n, peaks );
/*
    instances++;
    true_positive = 0;
    false_positive = 0;
    false_negative = 0;
    true_negative = 0;
    error = 0;
    // for each predicted peak check if true_positive or false_positive
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  91) ||
	    (peaks[i] ==  92) ) {
	    true_positive++;
	}
	else {
	    false_positive++;
	    error += min( abs(peaks[i] -  91),
	    		  abs(peaks[i] -  92) );
	}
    }
    // for each actual peak check if true_positive or false_negative
    for( i = 0; i < n; i++ ) {
	if( (peaks[i] ==  91) ||
	    (peaks[i] ==  92) ) break;
    }
    if( i >= n ) false_negative++;
    true_negative = 167 - n - false_negative;
    if( detail ) {
        printf( "-------------------\n" );
        printf( "LowLight:   %3d %3d\n", true_positive, false_positive );
        printf( "            %3d %3d\n", false_negative, true_negative );
    }
    precision += (double)true_positive / (double)n;
    recall += (double)true_positive / 1.0;
    specificity += (double)true_negative
			/ (double)(false_positive + true_negative);
    mean_error += (double)error / (double)n;
*/

    // determine means
    double mean_recall = 100.0*recall/(double)instances;
    double mean_precision = 100.0*precision/(double)instances;
    printf( "-------------------\n" );
    printf( "instances        = %d\n", instances );
    printf( "mean precision   = %0.2f\n", mean_precision );
    printf( "mean recall      = %0.2f\n", mean_recall );
    printf( "F_1                 = %0.2f\n",
	2.0 * mean_precision * mean_recall
		/ (mean_precision + mean_recall) );
    printf( "F_0.5               = %0.2f\n",
	(1.0 + 0.5*0.5) * mean_precision * mean_recall
		/ (0.5*0.5*mean_precision + mean_recall) );
    printf( "mean sensitivity = %0.2f\n", mean_recall );
    printf( "mean specificity = %0.2f\n",
	100.0*specificity/(double)instances );
    printf( "mean absolute prediction errors = %0.2f lens steps\n",
	mean_error/(double)instances );
    printf( "\n" );
}

void
getPeaks( int &n, int peaks[] )
{
    int i;
    char line[2048];

    n = 0;
    fgets( line, 2048, stdin );
    for( i = 0; line[i] != ':'; i++ ) ;
    if( i >= 2048 ) printf( "trouble\n" );
    while( line[i] != '\n' ) {
	i++;
	if( i >= 2048 ) printf( "trouble\n" );
	if( isdigit(line[i]) ) {
	    int k = atoi( &line[i] );
	    peaks[n] = k;
	    n++;
	    while( isdigit(line[i]) ) i++;
	}
    }
}

int  min( int a, int b )
{
    if( a < b ) return( a );
    else	return( b );
}

int  min( int a, int b, int c )
{
    if(       (a <= b) && (a <= c) ) return( a );
    else if ( (b <= a) && (b <= c) ) return( b );
    else			     return( c );
}

int  min( int a, int b, int c, int d )
{
    return( min( min( a, b ), min( c, d ) ) );
}

